﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Basic_Terminal
{
    public enum Bluepro_t
    {
        bluecell_header0 = 0,
        bluecell_header1,
        bluecell_header2,
        bluecell_header3,
        bluecell_type,
        bluecell_length01,
        bluecell_length02,
    };
    
    class Bluecell_BootProtocol
    {
        Serial serial;
        /*bluecell Header*/
        public const byte Bluecell_Header0 = 0x42;//ASCII : B
        public const byte Bluecell_Header1 = 0x4C;//ASCII : L
        public const byte Bluecell_Header2 = 0x55;//ASCII : U
        public const byte Bluecell_Header3 = 0x45;//ASCII : E
        /*bluecell type*/
        public const byte Bluecell_Reset = 0x52;//ASCII : R
        public const byte Bluecell_Firmupdate_start    = 0x55;//ASCII : U
        public const byte Bluecell_Firmupdate_sending  = 0x53;//ASCII : S
        public const byte Bluecell_Firmupdate_end      = 0x65;//ASCII : e

        public const int bluecell_Firmupdate_sendlength = 1024;
        Crc16 crc16 = new Crc16();

        public int Bluecell_Firmupdate_sendlength() {
            return bluecell_Firmupdate_sendlength;
        }

        public byte[] Boot_Reset(object serial)
        {
            this.serial = (Serial)serial;
            byte[] fix_data = new byte[8];
            //Array.Clear(data, 0, data.Length);
            fix_data[(int)Bluepro_t.bluecell_header0] = Bluecell_Header0;
            fix_data[(int)Bluepro_t.bluecell_header1] = Bluecell_Header1;
            fix_data[(int)Bluepro_t.bluecell_header2] = Bluecell_Header2;
            fix_data[(int)Bluepro_t.bluecell_header3] = Bluecell_Header3;
            fix_data[(int)Bluepro_t.bluecell_type]    = Bluecell_Reset;
            fix_data[(int)Bluepro_t.bluecell_length01]  = 0;
            fix_data[(int)Bluepro_t.bluecell_length02]  = 5;

            fix_data[(int)Bluepro_t.bluecell_type + 1] = Convert.ToByte((crc16.CRC16_Generate(fix_data, fix_data.Length) & 0xFF00) >> 8);
            fix_data[(int)Bluepro_t.bluecell_type + 2] = Convert.ToByte((crc16.CRC16_Generate(fix_data, fix_data.Length) & 0x00FF));
            this.serial.Serial_DataSend(fix_data, fix_data.Length);
            return fix_data;            
        }
        public byte[] Boot_DataStart()
        {
            //Array.Clear(data, 0, data.Length);
            byte[] fix_data = new byte[9];
            fix_data[(int)Bluepro_t.bluecell_header0] = Bluecell_Header0;
            fix_data[(int)Bluepro_t.bluecell_header1] = Bluecell_Header1;
            fix_data[(int)Bluepro_t.bluecell_header2] = Bluecell_Header2;
            fix_data[(int)Bluepro_t.bluecell_header3] = Bluecell_Header3;
            fix_data[(int)Bluepro_t.bluecell_type]    = Bluecell_Firmupdate_start;
            fix_data[(int)Bluepro_t.bluecell_length01]  = 0;
            fix_data[(int)Bluepro_t.bluecell_length02]  = 3;
            fix_data[(int)Bluepro_t.bluecell_type + 1] = Convert.ToByte((crc16.CRC16_Generate(fix_data, fix_data.Length) & 0xFF00) >> 8);
            fix_data[(int)Bluepro_t.bluecell_type + 2] = Convert.ToByte((crc16.CRC16_Generate(fix_data, fix_data.Length) & 0x00FF));
            return fix_data;
        }
        public byte[] Boot_DataSending(byte[] data,int length)
        {
            //Array.Clear(data, 0, data.Length);
            byte[] fix_data = new byte[5];
            fix_data[(int)Bluepro_t.bluecell_header0] = Bluecell_Header0;
            fix_data[(int)Bluepro_t.bluecell_header1] = Bluecell_Header1;
            fix_data[(int)Bluepro_t.bluecell_header2] = Bluecell_Header2;
            fix_data[(int)Bluepro_t.bluecell_header3] = Bluecell_Header3;
            fix_data[(int)Bluepro_t.bluecell_type]    = Bluecell_Firmupdate_sending;
            fix_data[(int)Bluepro_t.bluecell_length01] = Convert.ToByte((length & 0xFF00) >> 8);
            fix_data[(int)Bluepro_t.bluecell_length02] = Convert.ToByte((length & 0x00FF));
            return data;
        }
        public byte[] Boot_DataEnd()
        {
            //Array.Clear(data, 0, data.Length);
            byte[] fix_data = new byte[5];
            fix_data[(int)Bluepro_t.bluecell_header0] = Bluecell_Header0;
            fix_data[(int)Bluepro_t.bluecell_header1] = Bluecell_Header1;
            fix_data[(int)Bluepro_t.bluecell_header2] = Bluecell_Header2;
            fix_data[(int)Bluepro_t.bluecell_header3] = Bluecell_Header3;
            fix_data[(int)Bluepro_t.bluecell_type]    = Bluecell_Firmupdate_end;
            fix_data[(int)Bluepro_t.bluecell_length01] = 0;
            fix_data[(int)Bluepro_t.bluecell_length02] = 3;

            return fix_data;
        }
    }
}
