﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
//Add code
using System.Windows.Forms;
using System.IO;
using System.IO.Ports;

namespace Basic_Terminal
{
    class Serial
    {
        private System.IO.Ports.SerialPort serialPort;
        private Debug Debug = new Debug();    // Teminal Text Wnd Open
        public string Serial_Name { get => serialPort.PortName;  set => serialPort.PortName = value;}
        Data_Handler data_Handler = new Data_Handler();
        FileDownload fileDownload;
        public void Serial_Initialize(ref ComboBox cb_port)
        {
            
            this.serialPort = new System.IO.Ports.SerialPort();
            this.serialPort.DataReceived += new System.IO.Ports.SerialDataReceivedEventHandler(this.Serial_DataRecvFunction);

            cb_port.BeginUpdate();
            foreach (string comport in SerialPort.GetPortNames())//foreach (string comport in SerialPort_TestProgram.GetPortNames())
            {
                cb_port.Items.Add(comport);
            }
            cb_port.EndUpdate();
            //SerialPort 초기 설정.
            cb_port.DataSource =  SerialPort.GetPortNames();
            serialPort.PortName = Serial_Name = cb_port.SelectedItem.ToString();
            serialPort.BaudRate = (int)115200;
            serialPort.DataBits = (int)8;
            serialPort.Parity = System.IO.Ports.Parity.None;
            serialPort.StopBits = StopBits.One;

        }
        private delegate void StringSend(string Text);
        private delegate void ByteSend(byte[] Text);

        public string str2hex(string strData,Boolean Compotable)
        {
            string resultHex = string.Empty;
            byte[] arr_byteStr = Encoding.Default.GetBytes(strData);

            foreach (byte byteStr in arr_byteStr)
            {
                if(Compotable == true)
                    resultHex += string.Format("{0:X2}", byteStr) + " ";
                else
                    resultHex += string.Format("{0:X2}", byteStr);
            }

            return resultHex;
        }

        static public byte[] str2bytes(string byteData)
        {
            System.Text.ASCIIEncoding asencoding = new System.Text.ASCIIEncoding();
            return Encoding.Default.GetBytes(byteData);
        }

        public void Serial_DataRecvFunction(object sender, SerialDataReceivedEventArgs e)
        {
            
            string data = serialPort.ReadExisting();
            if(Debug.RadioButton_ascii.Checked == true)
                Debug.Invoke(new StringSend(Debug.Data_Recv_Str), data);
            else
                Debug.Invoke(new StringSend(Debug.Data_Recv_Str), str2hex(data,true));

            data_Handler.Recv_dataCheck(this.fileDownload, str2bytes(str2hex(data,false)));
        }
        public Boolean Serial_PortOpen(ref Button Btn_Portonoff)
        {
            Boolean ret = false;
            try
            {
                if (serialPort.IsOpen) { //When the port is open
                    serialPort.Close();
                    Btn_Portonoff.Text = "Port Open";
                    ret = true;
                }
                else//When the port is close
                {
                    serialPort.Open();
                    Btn_Portonoff.Text = "Port Close";
                }
            }
            catch
            {
                MessageBox.Show("already port open " + Serial_Name);
               
            }
            return ret;
        }
        public void Serial_TerminalOpen(object serial)
        {
            this.Debug.Serial_ClassSet(serial);
            try
            {
                this.Debug.Show();
            }
            catch
            {
                Debug = new Debug();
                this.Debug.Show();
            }
        }
        public void Serial_DataSend(byte[] data)
        {
            try
            {
                serialPort.Write(data,0,data.Length);
            }
            catch (System.Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
        public void Serial_DataSend(byte[] buffer, int count)
        {
            try { serialPort.Write(buffer, 0, count); }
            catch { MessageBox.Show("Port Open Failed!!!"); }
        }
        public void FileDownloadClass_Get(object filedownload)
        {
            this.fileDownload = (FileDownload)filedownload;
        }
    }
}
